package org.norberg.XmlTvToVdr;

import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.util.StringTokenizer;

/**
 * (c) 2003 Stefan Norberg (stefan@norberg.org)
 */
public class Util {

	private Util instance;
	
	private static int currentEventId = 0;

	private Util() {
	}
	
	/**
	 * Returns the currentEventId.
	 * @return int
	 */
	public static int getCurrentEventId() {
		if (currentEventId == 0) {
			currentEventId = Util.getHighestEventIdFromVdr();
		}
		return currentEventId++;
	}
	
	private static int getHighestEventIdFromVdr() {
		Socket s = new Socket();
		int highest = 0;

		try {
			s.connect(new InetSocketAddress(PropertiesManager.getInstance().getVdrHostname(), 
											PropertiesManager.getInstance().getSvdrpPort()));
			InputStreamReader in = new InputStreamReader(s.getInputStream());
			OutputStreamWriter out = new OutputStreamWriter(s.getOutputStream());
			out.write("LSTE\n");
			out.flush();
			out.write("QUIT\n");
			out.flush();
			char[] buf = new char[8192];
			StringBuffer sb = new StringBuffer();
			int bytesRead;
			while ((bytesRead = in.read(buf,0, 8192)) != -1) {
				for (int i = 0; i < bytesRead; i++)
					sb.append(buf[i]);
			}
			out.close();
			in.close();
			s.close();
			
			int occursAt = 0;

			while (occursAt != -1) {
				occursAt = sb.indexOf("215-E ", occursAt + 1 );
				StringTokenizer st = 
				  new StringTokenizer(sb.substring(occursAt+5, occursAt + 20), " ");
				try {
					highest = Math.max(new Integer(st.nextToken()).intValue(), highest);
				} catch (NumberFormatException e) {
					;
				}
		    }
		} catch (IOException e) {
			e.printStackTrace();
		}
		currentEventId = highest;
		return highest;
	}
	public static void uploadEpgInfo(Channel[] channel) {
		Socket s = new Socket();
		int highest = 0;

		try {
			s.connect(new InetSocketAddress(PropertiesManager.getInstance().getVdrHostname(), 
											PropertiesManager.getInstance().getSvdrpPort()));
			InputStreamReader in = new InputStreamReader(s.getInputStream());
			OutputStreamWriter out = new OutputStreamWriter(s.getOutputStream());
			out.write("PUTE\n");
			for (int i = 0; i < channel.length; i++) {
				out.write(channel[i].vdrFormat());
				out.flush();
			}
			out.write(".\n");
			out.write("QUIT\n");
			out.flush();
			char[] buf = new char[8192];
			StringBuffer sb = new StringBuffer();
			int bytesRead;
			while ((bytesRead = in.read(buf,0, 8192)) != -1) {
				for (int i = 0; i < bytesRead; i++)
					System.out.print(buf[i]);
			}
			out.close();
			in.close();
			s.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
			
	}
}
