package org.norberg.XmlTvToVdr;

import java.util.Iterator;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

/**
 * (c) 2003 Stefan Norberg (stefan@norberg.org)
 */
public class XmlTvParser {
	
	Document document;
	
	public XmlTvParser(String filename) {
        SAXReader reader = new SAXReader();

		try {
			document = reader.read(filename);
		} catch (DocumentException e) {
			System.out.print(e.getMessage());
		}
	}

	public void parse() {
		Element element = document.getRootElement();
		
		Iterator programme = element.elementIterator("programme");
		
		while (programme.hasNext()) {
			Element eventElement = (Element) programme.next();
			String start = eventElement.attribute("start").getStringValue();
			String end = eventElement.attribute("stop").getStringValue();
			String channel = eventElement.attribute("channel").getStringValue();
			String title = eventElement.element("title").getText();
			String description = null;
			if (eventElement.element("desc") != null) {
				description = eventElement.element("desc").getText();
			}
			Channel ch = ChannelFactory.getInstance().getChannel(channel);
			if (ch.countEvents() == 0) {
				ch.setVdrName(PropertiesManager.getInstance().getChannelName(channel));
				ch.setVdrServiceId(PropertiesManager.getInstance().getServiceId(channel));
			}
			ch.addEvent(new EpgEvent(title, description, start, end));
		}
	}
}
